package cn.timer.api.utils.router.business;

import org.springframework.beans.factory.annotation.Autowired;

import cn.timer.api.utils.router.enums.ApproveEnum;

/**
 * 审批关联业务工厂类
 * @author Tang
 *
 */
public class SpmkAssoBusinessFactory {
	
	@Autowired
	private RegularizationBusiness regularizationBusiness;
	@Autowired
	private TransferPositionBusiness transferPositionBusiness;
	@Autowired
	private ResignationBusiness resignationBusiness;
	@Autowired
	private RecruitBusiness recruitBusiness;
	@Autowired
	private WorkOvertimeBusiness workOvertimeBusiness;
	@Autowired
	private LeaveBusiness leaveBusiness;
	@Autowired
	private EvectionBusiness evectionBusiness;
	@Autowired
	private GoOutBusiness goOutBusiness;
	@Autowired
	private ReissueACardBusiness reissueACardBusiness;
	
	static SpmkAssoBusinessFactory factory;
	
	public static SpmkAssoBusinessFactory getFactory() {
		
		return factory == null ? new SpmkAssoBusinessFactory() : factory;
		
	}

	public SpmkAssoBusiness createSpmkAssoType(ApproveEnum assotype) {
		SpmkAssoBusiness sat = null;
		switch (assotype) {
		case DEFAULT:
			break;
		case REGULARIZATION:
			sat = regularizationBusiness;
			break;
		case RESIGNATION:
			sat = resignationBusiness;
			break;
		case TRANSFER_POSITION:
			sat = transferPositionBusiness;
			break;
		case RECRUIT:
			sat = recruitBusiness;
			break;
		case WORK_OVERTIME:
			sat = workOvertimeBusiness;
			break;
		case LEAVE:
			sat = leaveBusiness;
			break;
		case EVECTION:
			sat = evectionBusiness;
			break;
		case GO_OUT:
			sat = goOutBusiness;
			break;
		case REISSUE_A_CARD:
			sat = reissueACardBusiness;
			break;
		default:
			break;
		}
		
		return sat;
		
	}
	
}
